package EDU.auburn.VGJ.frontend;

import EDU.auburn.VGJ.graph.*;
import EDU.auburn.VGJ.gui.*;
import webflow.backend.*;
import webflow.frontend.*;
//import webflow.frontend.ModuleControls.CPanel;
import EDU.syr.npac.frontend.CPanel;
import EDU.syr.npac.frontend.FEHash;
import java.util.*;
import java.net.*;
import java.io.*;

public class compgraph {

  private NodeList List;
  private Node  node;
  private int   imax;
  private int    i,j;
  private int idx,id;
  private int   nedg;
  private String moduleName;
  String smURL;
  GraphWindow GW;
  Hashtable edges;
  int ntotal;
  String hostName;
  String ClientID;
  int portNumber;
  CPanel am;
  //  Hashtable moduleClass;
  FEHash FEclasses;
  compnode[] CompNodeList;
  compnode Cnode, fromCnode, toCnode;

  private SMreply _smreply;
  private SMreply _connect;
  private ID fromPort, toPort, fromModule, toModule;
  private String dir;

  public compgraph(GraphWindow GW_, NodeList NodeList_, Hashtable Edges_, String SM_URL) {
    List = NodeList_;
    smURL = SM_URL;
    GW = GW_;
    edges = Edges_;
    CompNodeList = new compnode[15];

  }


  public void tomnodelist () {


    System.err.println("======== RUN: START PROCESSING============");
    System.err.println("==========================================");

    FEclasses = new FEHash(); 
    imax = List.count();
    hostName = GW.hostName;
    ClientID = GW.ClientID;
    portNumber = GW.portNumber;   
    am = GW.tomPanel.Executor;
    ntotal=0;
    ID portID = null;

    if(imax>0) {
      node = List.firstNode();
      moduleName=node.getLabel();
      dir=node.getModuleDir();
      if(dir==null) {
          /* this is cheatting
          find the first occurence of the current Label in modules.txt
          at this time there is no way to store dir name
          solution: make dir part of the label, something like dir.Label, 
          and disply only Label
	  */
         dir=GW.tomPanel.currModules.firstDir(moduleName); 
         node.setModuleDir(dir);
      }

      node.ModuleClassPath=GW.tomPanel.currModules.getModuleClass(moduleName,dir);
      String moduleHost=GW.tomPanel.currModules.getModuleServer(moduleName,dir);  
      String classfrommodules = node.ModuleClassPath;
      _smreply=requestInit(classfrommodules,moduleHost);
      if(_smreply != null) {
        System.err.println("received reply..."); 
	if(_smreply.getStatus() == SMreply.HTML) {
           System.err.println("....HTML.... requested"); 
           int key = _smreply.getHtmlKey();
           // Ask webEditor to open a window for this module
           String wName = _smreply.getViewerWinName();
           if(wName!=null) wName+=_smreply.getModuleID();
           String appletURL=new String( smURL + "?cmd=get_viewer&viewerID="+key+"&ClientID="+ClientID);
           showViewer( appletURL , wName );
	}
      }
      else {
           System.err.println("SOMETHING WENT WRONG !!!!!!!!!!!!!!");
           System.err.println("smreply is null for "+moduleName);
      }


      /* missing stuff
      SMreply reply = wed.requestInit(mli);

      if(DEBUG==true)
         System.out.println("postPlacement START for module " + mli.getClassName());

      if(reply != null) 
      {
	     if(DEBUG==true) 
             System.out.println("SMreply status = " + reply.getStatus());

	     if(reply.getStatus() == SMreply.OK) 
         {  initModule(mli, reply.getModuleID(), reply.getPortList()); } 
         else if(reply.getStatus() == SMreply.HTML) 
              {  
                 initModule(mli, reply.getModuleID(), reply.getPortList());
	             int key = reply.getHtmlKey();

	             if(DEBUG==true) System.out.println("HtmlKey = " + key);

               // Ask webEditor to open a window for this module
                 String wName = reply.getViewerWinName();
                 if(wName!=null) wName+=reply.getModuleID();
	             wed.newViewer( key, wName );

	          }
	     else {
                if(DEBUG==true)
	              System.out.println("Invalid SMreply status = " + reply.getStatus());
	          }

      } else { if(DEBUG==true) System.out.println("SMreply = null"); }

      if(DEBUG==true) System.out.println("postPlacement END ");

  }// end of postPlacement()

     DO NOT FORGRT YOU NEED IT TWICE

      */


      System.err.println(":::: "+moduleName);
      System.err.println("++++ "+classfrommodules);
      System.err.println("moduleWebID: ");
      System.err.println("moduleWebID: "+(_smreply.getModuleID()).getInt());
      System.err.println("-------- returned from requestInit ------------");

      Vector tmpPortList = _smreply.getPortList();
      int tmpListLenght = tmpPortList.size();
      System.err.println("#### number of ports: "+tmpListLenght);
      for (j=0;j<tmpListLenght;j++) {
         ID tmpPortID = (ID) tmpPortList.elementAt(j);
         System.err.println("port # "+j+" id="+tmpPortID.getInt());
      }

      node.setBackendInfo(_smreply.getModuleID(),_smreply.getPortList()); 

      if(imax>1) {
       for(i=1;i<imax;i++) {
          node = List.nextNode(node);
          moduleName=node.getLabel();
          dir=node.getModuleDir();
          if(dir==null) {
            /* this is cheatting
            find the first occurence of the current Label in modules.txt
            at this time there is no way to store dir name
            solution: make dir part of the label, something like dir.Label, 
            and disply only Label
	    */
          dir=GW.tomPanel.currModules.firstDir(moduleName); 
          node.setModuleDir(dir);
          }

          node.ModuleClassPath=GW.tomPanel.currModules.getModuleClass(moduleName,dir);
          moduleHost=GW.tomPanel.currModules.getModuleServer(moduleName,dir);  
          classfrommodules = node.ModuleClassPath;         
          _smreply=requestInit(classfrommodules,moduleHost);

      if(_smreply != null) {
	if(_smreply.getStatus() == SMreply.HTML) {
           int key = _smreply.getHtmlKey();
           // Ask webEditor to open a window for this module
           String wName = _smreply.getViewerWinName();
           if(wName!=null) wName+=_smreply.getModuleID();
           String appletURL=new String( smURL + "?cmd=get_viewer&viewerID="+key+"&ClientID="+ClientID);
           showViewer( appletURL , wName );
	}
      }
      else {
           System.err.println("SOMETHING WENT WRONG !!!!!!!!!!!!!!");
           System.err.println("smreply is null for "+moduleName);
      }
 
      System.err.println(":::: "+moduleName);
      System.err.println("++++ "+classfrommodules);
      System.err.println("moduleWebID: "+(_smreply.getModuleID()).getInt());
      System.err.println("-------- returned from requestInit ------------");

      tmpPortList = _smreply.getPortList();
      tmpListLenght = tmpPortList.size();
      System.err.println("#### number of ports: "+tmpListLenght);
      for (j=0;j<tmpListLenght;j++) {
         ID tmpPortID = (ID) tmpPortList.elementAt(j);
         System.err.println("port # "+j+" id="+tmpPortID.getInt());
      }

      node.setBackendInfo(_smreply.getModuleID(),_smreply.getPortList()); 
      }
     }

      System.err.println("... now Edges ...");
      
      Enumeration active_edges = edges.keys();
      while(active_edges.hasMoreElements())
	{
         SDPoint currEdge = (SDPoint)(active_edges.nextElement());
         System.err.println(".........next edge......");
     
         System.err.println("SRCE : "+currEdge.dest_);
         System.err.println("DEST : "+currEdge.source_);
         System.err.println("INT DEST : "+currEdge.intSource);
         System.err.println("INT SRCE : "+currEdge.intDest);
         System.err.println("HEAD : "+currEdge.head_);
         System.err.println("TAIL : "+currEdge.tail_);

         Node fromNode = List.nodeFromIndex(currEdge.head_);
         ID fromNodeWFid = fromNode.WFid;
         System.err.println("fromNode ID: "+fromNodeWFid.getInt()); 

         Node toNode = List.nodeFromIndex(currEdge.tail_);
         dir=toNode.getModuleDir();

	 /*
          if(dir==null) {

          dir=GW.tomPanel.currModules.firstDir(moduleName); 
          toNode.setModuleDir(dir);
          }
          */

         ID toNodeWFid = toNode.WFid;
         System.err.println("  toNode ID: "+toNodeWFid.getInt()); 

	 /*
         Front End port numbering convention:

            0    1    2       input ports   (DESTINATION)
          ---------------
          |    module   |
          ---------------
          102   101  100      output ports  (SOURCE)

         */
         System.err.println("... find ports ID ...");



	 // determine shape of the module (i.e., # ports)
 
      int outPorts = GW.tomPanel.currModules.getNumberOutPorts(fromNode.getLabel(),fromNode.getModuleDir());
      int  inPorts = GW.tomPanel.currModules.getNumberInPorts(toNode.getLabel(),toNode.getModuleDir());

         // first output ports of fromNode  ("fromPort")


      int FEfromPort = currEdge.intDest;
      System.err.println("FrontEnd ID of output port: "+FEfromPort);

      if(outPorts==1) FEfromPort=0;
      if(outPorts==2 && FEfromPort==100) FEfromPort=0;
      if(outPorts==2 && FEfromPort==102) FEfromPort=1;
      if(outPorts==3) FEfromPort -= 100;

      System.err.println("corrected FE ID of output port: "+FEfromPort);
      ID fromPort = (ID) fromNode.WFportList.elementAt(FEfromPort);
      System.out.println("fromPort: "+fromPort.getInt());

         // then input ports of toNode ("toPort")

      int FEtoPort = currEdge.intSource;
      System.err.println("FrontEnd ID of input port: "+FEtoPort);
      System.err.println("# inports ports: "+inPorts);

      if(inPorts==1) FEtoPort=0;
      // if(inPorts==2 && FEtoPort==0) FEtoPort=0; (do nothing)
      if(inPorts==2 && FEtoPort==102) FEtoPort=1;
      // if(inPorts==3) do nothing;

      FEtoPort += GW.tomPanel.currModules.getNumberOutPorts(toNode.getLabel(),toNode.getModuleDir());
      ID toPort = (ID) toNode.WFportList.elementAt(FEtoPort);
      System.out.println("toPort: "+toPort.getInt());

      _connect=connect(fromPort, toPort, fromNodeWFid,toNodeWFid);
   
     } 
     
    }

   System.err.println("connection done - start frontend");
   am.lp.startModules();
   System.err.println("connections done - start backend");
   SMreply runnit=runModules();
   System.err.println("modules started");
  }

  // adopted from WebEeditor

  /**
  * <ol>
  *  <li> Open an Url connection to the SessionManager Object
  *  <li> Tell her your ClientId, new_module request and the name of the module.
  *  <li> Wait its response.
  *  <li> If the first word of first line is OK, this means that 
  *       she got the message and everything is ok. Then read the
  *       port number from the second line to read the result of the
  *       operation.
  * </ol>
  *
  */

  SMreply requestFromServer(String request) {

    SMreply reply = null;
    int current_portNumber = -1;

    if(request==null) return null;

    try
    {
      System.err.println("start requestFromServer");
      //Added by Erol for chache problem
      Date dt = new Date ();
      String tmp = Long.toString(dt.getTime());
      request = request+"&time="+tmp;
      System.err.println("request: "+request);
           
      URL myReq = new URL(request);
      
      try
      {
        DataInputStream dis = new DataInputStream( myReq.openStream() );
        
        String status = dis.readLine();
        StringTokenizer STstatus = new StringTokenizer(status);
        
   System.err.println(" I read status :"+status);

        if( STstatus.countTokens() > 0 &&  
            STstatus.nextElement().equals("OK")  )
        {
          String SportNumber = dis.readLine();
          System.err.println(" I read SportNumber:"+SportNumber);
          
          current_portNumber = Integer.parseInt(SportNumber); 

        } else return reply;

      } catch ( IOException e)
        {
           System.err.println("IOException is raised!");
           e.printStackTrace();
           return reply;
        }

    } catch ( MalformedURLException mue)
      {
        System.err.println(" MalformedURLException is raised!");
        mue.printStackTrace();
        return reply;
      } 
 
    /** If port number is invalid exit */
    if( current_portNumber < 1 ) return reply;

    System.err.println("port number seems to be OK");

    Socket Csocket = null;
    DataInputStream  Cdin  = null;
    DataOutputStream Cdout = null;

    try
    {
      Csocket = new Socket(hostName, current_portNumber );

      Cdin = new DataInputStream( Csocket.getInputStream() );

      Cdout = new DataOutputStream( Csocket.getOutputStream() );

    } catch( UnknownHostException e)
      {
         System.err.println("UnknownHostException" + e +" raised!");
         e.printStackTrace(); 
         return reply;
      }
      catch( IOException e)
      {
         System.err.println("IOException (2)" + e + " raised!");
         e.printStackTrace(); 
         return reply;
      }
       
    System.err.println("create empty reply");   
    reply = new SMreply();
    System.err.println("created empty reply");   

    try
    {
      reply.fromStream(Cdin);
      System.err.println("got reply?"); 
      System.err.println("reply? "+reply.getStatus()+" x");

      if(reply.getStatus() == SMreply.ERROR) 
       	System.err.println( reply.getDescription());

    } catch( NullPointerException e)
      {
         System.err.println("NullPointerException vo requestInit" + e);
         e.printStackTrace();
         return null;
      }

    System.err.println("ready to return from requestFromServer");
    return reply;

  }// end of requestFromServer()

  /**
  * Initialize the module
  */
  public SMreply 
  requestInit(String moduleClassName, String moduleHost)
  //  requestInit(ModuleTreeItem m)
  { 
     String myreq = new String(smURL+"?cmd=new_module&ClientID="+
                               ClientID+"&name="+moduleClassName);

     System.err.println("req(InitModule):"+ myreq);


     ntotal++;
     if(ntotal>10) {System.out.println("too many modules!!!!!!!!!!!!!!!");}
     int lastdot = moduleClassName.lastIndexOf(".")+1;
     String mname = moduleClassName.substring(lastdot);
     System.out.println("---> HASH of "+mname);
     Integer r1 = (Integer)FEclasses.ModuleNames.get(mname);
     System.out.println("R1: "+r1+" of "+ntotal);
     
     if(r1 != null) {
         int r2 = r1.intValue();
         am.addNewModule(ntotal,r2,mname,moduleHost);
     }
     else {
        am.addNewModule(ntotal,0,mname,moduleHost);
     }

     System.out.println("End of requestInit ");

     return requestFromServer(myreq); 
  }// end of requestInit()


  /**
  */
  public SMreply
  connect(ID from, ID to, ID fromModule, ID toModule )
  {
    String req = new String(smURL+"?cmd=connect&ClientID="+ClientID);
    req += "&fromStr="+from.getString();
    req += "&fromVal="+from.getInt();
    req += "&toStr="+to.getString();
    req += "&toVal="+to.getInt();
    req += "&mIDfromStr="+fromModule.getString();
    req += "&mIDfromVal="+fromModule.getInt();
    req += "&mIDtoStr="+toModule.getString();
    req += "&mIDtoVal="+toModule.getInt();

    return requestFromServer( req );

  }// end of connect()

  /**
  * Runs all the modules in the current session
  */
  public SMreply
  runModules()
  {
     String req = new String(smURL+"?cmd=run_modules&ClientID="+ClientID);
     System.err.println("runRequest="+req);
     return requestFromServer(req);

  }// end of run()

  /**
  * public version of SMreply destroy that is void (TH)
  */

  public void destroyAll() {
  _smreply = destroy();
  }    

  /**
  * Destroys all the modules in the current session
  */
  public SMreply
  destroy()
  {
    am.clean();
    ntotal=0;
    

     String req = new String(smURL+"?cmd=destroy_modules&ClientID="+ClientID);

     SMreply rett= requestFromServer(req);

     if( rett == null ) 
         rett = new SMreply(SMreply.ERROR,"Unkown");

     return rett ;

  }// end of destroy()


  //from WebFlowEditor

  /**
  * Shows the given Url in the given netscape window
  */
  public void 
  showViewer( String viewerURL , String WinName)
  {
    URL url = null;
    try
    {  
       url = new URL( viewerURL );

       System.err.println(" URL OK!");

       /** Show the url in the given netscape window */
       GW.applet.getAppletContext().showDocument( url, (WinName!=null?WinName : "Viewer") );

    } catch( MalformedURLException e )
      {  System.out.println(" Can not create URL from string "+viewerURL);
         e.printStackTrace();
      }
   
  }// end of showViewer()


}






