package EDU.auburn.VGJ.frontend;

import EDU.auburn.VGJ.graph.*;
import EDU.auburn.VGJ.gui.*;
import webflow.backend.*;
import webflow.frontend.*;
//import webflow.frontend.ModuleControls.CPanel;
import EDU.syr.npac.frontend.CPanel;
import EDU.syr.npac.frontend.FEHash;
import java.util.*;
import java.net.*;
import java.io.*;

public class compgraphCORBA {

  private NodeList List;
  private Node  node;
  private int   imax;
  private int    i,j;
  private int idx,id;
  private int   nedg;
  private String moduleName;
  String smURL;
  GraphWindow GW;
  Hashtable edges;
  int ntotal;
  String hostName;
  String ClientID;
  int portNumber;
  CPanel am;
  //  Hashtable moduleClass;
  FEHash FEclasses;
  compnode[] CompNodeList;
  compnode Cnode, fromCnode, toCnode;

  private SMreply _smreply;
  private SMreply _connect;
  private ID fromPort, toPort, fromModule, toModule;
  private String dir;

  String outNodeLabel, inNodeLabel;
  String EventID, MethodID;

  public compgraphCORBA(GraphWindow GW_, NodeList NodeList_, Hashtable Edges_, String SM_URL) {
    List = NodeList_;
    smURL = SM_URL;
    GW = GW_;
    edges = Edges_;
    CompNodeList = new compnode[15];

  }


  public void tomnodelist () {


    System.err.println("======== RUN: START PROCESSING============");
    System.err.println("==========================================");

    FEclasses = new FEHash(); 
    imax = List.count();
    hostName = GW.hostName;
    ClientID = GW.ClientID;
    portNumber = GW.portNumber;   
    am = GW.tomPanel.Executor;
    ntotal=0;
    ID portID = null;

    String ucr="userContextRef";
    String an="TestApplication";
    System.out.println("<taskspec UserContextRef=\"UserContextRef\" ApplicationName=\"an\">");
    System.out.println("<task>");

    if(imax>0) {
      node = List.firstNode();
      moduleName=node.getLabel();
      // module host??
      System.out.println("<module modulename=\"moduleName\" host=\"localhost\">");
      System.out.println("<\\module>");
    }

    if(imax>1) {
       for(i=1;i<imax;i++) {
          node = List.nextNode(node);
          moduleName=node.getLabel();
      moduleName=node.getLabel();
      // module host??
      System.out.println("<module modulename=\"moduleName\" host=\"localhost\">");
      System.out.println("<\\module>");
       }
      }

      System.err.println("... now Edges ...");
      
      Enumeration active_edges = edges.keys();
      while(active_edges.hasMoreElements())
	{
         SDPoint currEdge = (SDPoint)(active_edges.nextElement());
         System.err.println(".........next edge......");
     
	 /*
         System.err.println("SRCE : "+currEdge.dest_);
         System.err.println("DEST : "+currEdge.source_);
         System.err.println("INT DEST : "+currEdge.intSource);
         System.err.println("INT SRCE : "+currEdge.intDest);
         System.err.println("HEAD : "+currEdge.head_);
         System.err.println("TAIL : "+currEdge.tail_);
	 */

         Node fromNode = List.nodeFromIndex(currEdge.head_);
         outNodeLabel  = fromNode.getLabel();
         Node toNode = List.nodeFromIndex(currEdge.tail_);
         inNodeLabel = toNode.getLabel();

	 /*
         Front End port numbering convention:

            0    1    2       input ports   (DESTINATION)
          ---------------
          |    module   |
          ---------------
          102   101  100      output ports  (SOURCE)

         */
         System.err.println("... find ports ID ...");



         // first output ports of fromNode  ("fromPort")


      int FEfromPort = currEdge.intDest;
      System.err.println("FrontEnd ID of output port: "+FEfromPort);

      EventID="Event"+FEfromPort;

         // then input ports of toNode ("toPort")

      int FEtoPort = currEdge.intSource;
      System.err.println("FrontEnd ID of input port: "+FEfromPort);

      MethodID="Method"+FEtoPort;
      System.out.println("<connect>");
      System.out.println("<out modulename=\" "+outNodeLabel+"\"  eventname=\""+EventID+"\" event=\"dummy\">"); 
      System.out.println("<in modulename=\" "+inNodeLabel+"\" method=\""+MethodID+"\">");
      System.out.println("</connect>");
	}
      System.out.println("</task>");
      System.out.println("</taskspec>"); 

     System.err.println("connections done - start backend");
     
  }

}







