package EDU.auburn.VGJ.frontend;


import WebFlow.*;
import WebFlow.event.*;
import WebFlow.QS.*;
import org.omg.CORBA.*;
import java.io.*;
import java.net.*;
import java.util.*;
import EDU.auburn.VGJ.gui.*;
import javax.swing.*; 
import EDU.auburn.VGJ.*;

public class xmlClient {

  String xml;
  String[] args;
  configReader config;
  GraphWindow GW;
  ORB orb;


  public xmlClient(GraphWindow GW) {
      System.out.println("xmlClient constructor");
      this.GW=GW;
  }

  public void toXML (String xml) {

     this.xml = xml;
     System.out.println("start toXML");
     System.out.println(xml);
     args = new String[1];
     args[0]="http://128.230.21.212:8001/IOR/master.txt";
 try {
    System.out.println("...get applet...");

    VGJ a = GW.applet;
    System.out.println("...get orb...");

    orb = a.getORB();
    //    ORB orb = ORB.init(applet, new java.util.Properties());

    System.out.println("...masterURL...");


    String masterURL = args[0];

    String ref = getIORFromURL(masterURL);

    System.out.println("...IOR...");


    org.omg.CORBA.Object obj = orb.string_to_object(ref);

    System.out.println("...to_object...");


    if(obj == null) throw new RuntimeException();


    WebFlowContext master = WebFlowContextHelper.narrow(obj);

    System.out.println("...master...");

    if(master == null) throw new RuntimeException();
    System.out.println("Client: Created WFServerHelper");

     try{
        WebFlowContext slave = WebFlowContextHelper.narrow(master.getWFServer("ntserver"));
        if(slave == null) System.out.println("ERROR: slave not found!");
        else System.out.println("---->got ntserver");

	org.omg.CORBA.Object p1 = slave.addNewModule("xmlServer");
        if(p1 == null) System.out.println("ERROR: p1 not created ???");
        else System.out.println("---->got p1");

        xmlServer xmlp = xmlServerHelper.narrow(p1);

        if(xmlp == null) System.out.println("xmlp is null ???");
        else System.out.println("xmlp seems to be OK");

        System.out.println("save XML...");
        xmlp.saveXML(xml,"test");
        String xmlFile = "test";
        System.out.println("invoke the parser...");
        xmlp.parse(xmlFile);
        }catch(Exception e){System.out.println("Main:"+e);
	}
    }catch(Exception e) {

        System.out.println(e);

	//System.err.println(ex.getMessage());

	//ex.printStackTrace();

	System.exit(1);

    }
  }


    public static String  getIORFromURL(String url) {


	System.out.println("Slave WebFlow is getting IOR from url:"+url);


	String masterServerIOR="";


	String thisLine=null;


	//Open the URL for reading


      try {


        URL u = new URL(url);


        // now turn the URL into a DataInputStream


        try {


          DataInputStream theHTML = new DataInputStream(u.openStream());


          try {


            while ((thisLine = theHTML.readLine()) != null) {


              System.out.println("configReader:getIORfromURL:line"+thisLine);


		  masterServerIOR += thisLine;


            } // while loop ends here


          }  // end try


          catch (Exception e) {


            System.out.println("configReader:getIORfromURL:"+e);


          }


        } // end try


        catch (Exception e) {


          System.out.println("configReader:getIORfromURL:"+e);


        }





      } // end try


      catch (MalformedURLException e) {


        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");


        System.out.println("configReader:getIORfromURL:"+e);


      }

      

      return masterServerIOR;

      

    }
 
}
