package EDU.auburn.VGJ.gui;


import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

public class SwingServletClient
{
  Socket socket;
  ObjectInputStream dis;
  ObjectOutputStream dos;
  
  public SwingServletClient (String SM_URL)
  {
    String Host=null;
    int Port = 0;
    System.err.println("inside SwingServerClient "+SM_URL); 
    
    try{
      URL url = new URL(SM_URL);
      Host    = url.getHost();
      Port    = 5505;
    }catch (MalformedURLException ev){
      System.out.println("URL error in actionPerformed (run) " + ev);
    } 

    try{
     System.err.println("create a new Socket "+Host+":"+Port);    
     socket = new Socket(Host,Port);
      dis = new ObjectInputStream(socket.getInputStream());
      dos = new ObjectOutputStream(socket.getOutputStream());
    }catch(IOException  e){
      System.out.println("IOException "+e);
    }
    System.err.println("Socket created");
  }
  
  public void send(String message)
  {
    System.out.println("Outgoing String:"+message);
    try{
      dos.writeObject(message);
      dos.flush();
    }catch(OptionalDataException e){
      System.out.println("sendWFECommand "+e);
    }catch(IOException e){
      System.out.println("sendWFECommand "+e);
    }
  }

  public String receive()
  {
    Object message = null;
    
    try{
      message = dis.readObject();
     }catch(OptionalDataException e){
      System.out.println("recvWFEMessage "+e);
    }catch(ClassNotFoundException e){
      System.out.println("recvWFEMessage "+e);
    }catch(IOException e){
      System.out.println("recvWFEMessage "+e);
    }
    return((String)message);
  }

  
}
