package EDU.auburn.VGJ.gui;


import EDU.syr.npac.frontend.CPanel;
import EDU.auburn.VGJ.frontend.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

public class saveReadGML extends JPanel //JPanel
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  JPanel p;
  static String InitialRootDir;//="saved/";
  public static  GraphWindow gw;
  
  public saveReadGML (String InitialRootDir_,GraphWindow gw_) 
  {
    InitialRootDir = InitialRootDir_;
    FileTreeModel  root = new FileTreeModel(InitialRootDir,this);
    refreshFileBrowser(root ,InitialRootDir);
    gw = gw_;
  }

public  SwingServletClient waitUntilSocketReady()
  {
    return gw.swingClient;
  }

   
public void refreshFileBrowser(FileTreeModel  root,String rootName)
  {
    
    //remove all the components inside the Panel
    removeAll();
    
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setFont(new Font("Helvetica", Font.PLAIN, 14));
    setLayout(gridbag);

    selectedFile file_field = new selectedFile("",25,"file",this);
    
    DirTree tree = new DirTree(root,this);
    JScrollPane scrollPane = new JScrollPane(tree);
    tree.addMouseListener(file_field);
    tree.addTreeExpansionListener(root);
    root.addTreeModelListener(tree);

    
    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridwidth = GridBagConstraints.REMAINDER;

     //Next row
    JLabel label = new JLabel("Enter Path and Folder Name :");
    gridbag.setConstraints(label, c);
    add(label);

    final selectedFile directory_field=new selectedFile(rootName,25,
					       	"directory",this);
    tree.addMouseListener(directory_field);
    directory_field.addActionListener(root);
    

    gridbag.setConstraints(directory_field, c);
    add(directory_field);

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    c.gridheight = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(scrollPane, c);
    add(scrollPane);

    //Next row
    c.weightx = 0.0;
    c.weighty = 0.0;
    c.fill = GridBagConstraints.HORIZONTAL;
    label = new JLabel("Enter File Name :");
    gridbag.setConstraints(label, c);
    add(label);

    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(file_field, c);
    add(file_field);


    //Next Row 
    //c = new GridBagConstraints();
    //c.fill = GridBagConstraints.HORIZONTAL;
    //Button button = new Button("Save");
    //c.gridwidth = GridBagConstraints.RELATIVE;
    //gridbag.setConstraints(button, c);
    //button.addActionListener(file_field);
    //add(button);
    
    c.fill = GridBagConstraints.NONE;
    JButton  button = new JButton("Restore");
    c.gridwidth = GridBagConstraints.RELATIVE;
    gridbag.setConstraints(button, c);
    button.addActionListener(file_field);
    add(button);
       
    c.fill = GridBagConstraints.NONE;
    button = new JButton("Save");
    c.gridwidth = GridBagConstraints.RELATIVE;
    gridbag.setConstraints(button, c);
    button.addActionListener(file_field);
    add(button);
  }
    
     public static void main(String[] args) {
        /*
         * Create a window.  Use JFrame since this window will include 
         * lightweight components.
         */

        JPanel panel;
       
        Frame frame = new Frame("TreeDemo");
       	frame.setLayout( new BorderLayout() );
        WindowListener l = new WindowAdapter() {
	   public void windowClosing(WindowEvent e) {System.exit(0);}
        };
        frame.addWindowListener(l);
		
        //frame.add(BorderLayout.CENTER, new saveReadGML("444",8));
	frame.pack();
        //frame.move(60 + drawAreaSize.width, 10);frame.setSize(500, 500);
        frame.show();
    }
     
}


class selectedFile extends JTextField implements MouseListener,ActionListener
{
public String name;
public String fullFilePath;
saveReadGML viewer;
  
public selectedFile(String text,int colums,String name_,saveReadGML viewer_)
  {
    super(text,colums);
    name = name_;
    addActionListener(this);
    viewer = viewer_;
    fullFilePath = viewer.InitialRootDir;
  }

public String getEntered()
  {
    String se = getText();
    String fe = fullFilePath;
    int pos   = fe.lastIndexOf("/");
    if (pos > 0){
      fe  = fe.substring(0,pos)+"/";
      fe += se;
    }
    else{
      fe += "/"+se;
    }
    
    return fe;
        
  }
  
 public void actionPerformed(ActionEvent e) {
   if (name.equals("file")){
     String entered = getEntered();
     
     System.err.println("File :"+entered+" are sent in ActionPerformed!!!");
     String ac = e.getActionCommand() ;
     System.err.println("actionCommand :"+ac);
     
     if (ac.equals("Save")){
       saveReadGML.gw.saveGMLInServer(entered);
     }
     else if (ac.equals("Restore")){
       saveReadGML.gw.getGMLfromServer(entered);
       // should add restoring BackEnd info!!!!

     }
   }
 }
  

public void mouseClicked(MouseEvent e) {

  String dirName=null,fileName=null;
  
  System.err.println("inside  selectedFile!!!");
  Component source = e.getComponent();
  DirTree tree = (DirTree)source;
  
  int selRow = tree.getRowForLocation(e.getX(), e.getY());
  TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
      
  if (selPath != null){
    
    fullFilePath = tree.getSelectedItem(selPath);
    int index = fullFilePath.lastIndexOf("/");
    fileName  = fullFilePath.substring(index+1);
    dirName   = fullFilePath.substring(0,index);
  
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.err.println("One Cliect pressed inside selectedfile !!!");
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);
      }
      else if(e.getClickCount() == 2) {
	System.err.println("Two Cliect pressed inside selectedfile !!!");
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);

	if ((fileName.length() > 0)&&(name.equals("file"))){
	  System.err.println("File :"+fullFilePath+" are sent!!!");
	  SwingServletClient socket = viewer.waitUntilSocketReady() ;
	  socket.send("SWING_REPLY"+fullFilePath);
	}
      }
    }
  }
  
}
  

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }

  
}



class DirTree extends JTree implements MouseListener,TreeModelListener
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  public DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  JPanel p;
  public saveReadGML viewer;
  DataInputStream dis;
  DataOutputStream dos;
  
  
 public DirTree(DefaultTreeModel  root,saveReadGML viewer_)
  {
    super(root);
    addMouseListener(this);
    viewer = viewer_;
  }

    


  public void mouseClicked(MouseEvent e) {

    System.err.println("inside DIRTREE !!!");
    Component source = e.getComponent();
    DirTree tree = (DirTree)source;
  
    int selRow = tree.getRowForLocation(e.getX(), e.getY());
    TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.err.println("One Cliect pressed inside DIRTREE !!!");
	//mySingleClick(selRow, selPath);
      }
      else if(e.getClickCount() == 2) {
	System.err.println("Two Cliect pressed inside DIRTREE !!!");
	fireTreeExpanded(selPath);
      }
    }
  
  }
public String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    Object pathComponent =  selPath.getPathComponent(pcount-1);
    
   
    String fullPath="";
    for(int i=0;i<pcount;i++){
      TreeNode tn = (TreeNode)(selPath.getPathComponent(i));
      Object o = ((DefaultMutableTreeNode)tn).getUserObject();
      TreeNodeInfo tinfo = (TreeNodeInfo)o;

      String append = "";
      if ((tinfo.permission.indexOf('d') == 0)||((pcount>1)&&(i==0)))
	append = "/";
      fullPath += tinfo.toString()+append;
    }
    
    return fullPath;
  }

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }
 

public void   treeNodesChanged(TreeModelEvent e)
  {
    System.err.println("treeNodesChanged is CALLED !!! ");
    
  }
  

 public void    treeNodesInserted(TreeModelEvent e) 
{
    System.err.println(" treeNodesInserted  is CALLED !!! ");
    
  }
 public void    treeNodesRemoved(TreeModelEvent e) 
{
    System.err.println("treeNodesRemoved  is CALLED !!! ");
    
  }

 public void    treeStructureChanged(TreeModelEvent e)
 {
    System.err.println("treeStructureChanged  is CALLED !!! ");
    int row = getRowForPath(e.getTreePath());
    System.err.println("treeStructureChanged:row:"+row);
    //expandRow(row);
    
    
 }      
}

class FileTreeModel extends DefaultTreeModel implements  TreeExpansionListener,
ActionListener
{
  
  static saveReadGML viewer;
  DefaultMutableTreeNode root;
  
public FileTreeModel(String dirFullPath,saveReadGML viewer_)
  {
    super(constructTree(dirFullPath));
    viewer = viewer_;
    root   = (DefaultMutableTreeNode)(getRoot());
    
  }

  public void actionPerformed(ActionEvent e) {
      String dirname = e.getActionCommand();
      System.err.println("ActionListener: directory name: "+dirname);
      root.removeAllChildren();
      updateTree(dirname,root,dirname);
      System.err.println("After updateTree");
      reload();
      System.err.println("ActionListener:inside FileTreeModel");
   }

  public static DefaultMutableTreeNode constructTree(String dirFullPath)
    {
      String s;
      DefaultMutableTreeNode top=null,one=null;
      
      System.err.println("Filter :"+saveReadGML.InitialRootDir);
      if (dirFullPath.equals(saveReadGML.InitialRootDir)){
      	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(".");
      	firstNodeInfo.permission = "drwxr-xr-x";
      	top = new DefaultMutableTreeNode(firstNodeInfo);
        return top;
      }
        
	SwingServletClient socket = viewer.waitUntilSocketReady() ;
        socket.send("SWING_REQ"+dirFullPath);
	String pwd = socket.receive();

	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(pwd);
	firstNodeInfo.permission = "drwxr-xr-x";
	top = new DefaultMutableTreeNode(firstNodeInfo);
	System.err.println("rootDir "+pwd);
        
	String str_nfiles = socket.receive();
	int    nfiles     = Integer.parseInt(str_nfiles);
	System.err.println("nfiles  "+nfiles);
	
	socket.receive(); // read string "total xxxx" 
	
	for(int i=1;i<nfiles;i++)
	  {
	    s = socket.receive();
	    System.err.println("file "+s);
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals(".."))))
	      {
		System.err.println("adding to TREE");
		
		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.permission.indexOf('d') == 0){
		  String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
		  TreeNodeInfo tn_new = new TreeNodeInfo(n);
		  one.add(new DefaultMutableTreeNode(tn_new));
		}
	      }
	  }
       System.err.println("end of performe ");
       return top;
       
    }
  
   
  //Is directory containing only dummy file 
public boolean isDirDummy( DefaultMutableTreeNode lastComponent)
  {
     Object o = lastComponent.getUserObject();
     TreeNodeInfo parentInfo = (TreeNodeInfo)o;

     TreeNode removedOne = lastComponent.getChildAt(0); 
     o = ((DefaultMutableTreeNode)removedOne).getUserObject();
     TreeNodeInfo childInfo = (TreeNodeInfo)o;
     System.err.println("child="+childInfo.filename+"="+
		      "permission="+parentInfo.permission+"="+
		       "cnt="+lastComponent.getChildCount());
     

     if ((parentInfo.permission.indexOf('d') == 0)&&
         (lastComponent.getChildCount() == 1)&&
	 (childInfo.filename.equals("../"))){
       System.err.println("it is Dummy Node");
       return true;
     }
     
     else{
       System.err.println("it is NOT Dummy Node");
       return false;
     }
     
  }

public static int  updateTree(String dirFullPath,DefaultMutableTreeNode top,
			     String lastNodeName)
    {
        String s;
        DefaultMutableTreeNode one=null;
        int childCnt=0;

        System.err.println("Filter :updateTree");
        
	SwingServletClient socket = viewer.waitUntilSocketReady() ;
        socket.send("SWING_REQ"+dirFullPath);
	String pwd = socket.receive();

	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(lastNodeName);
	firstNodeInfo.permission = "drwxr-xr-x";
	top.setUserObject(firstNodeInfo);
	System.err.println("rootDir "+pwd);
        
	String str_nfiles = socket.receive();
	int    nfiles     = Integer.parseInt(str_nfiles);
	System.err.println("nfiles  "+nfiles);
	
	socket.receive(); // read string "total xxxx" 
	
	for(int i=1;i<nfiles;i++)
	  {
	    s = socket.receive();
	    System.err.println("file "+s);
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals(".."))))
	      {
		System.err.println("adding to TREE");
		childCnt++;

		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.permission.indexOf('d') == 0){
		  String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
		  TreeNodeInfo tn_new = new TreeNodeInfo(n);
		  one.add(new DefaultMutableTreeNode(tn_new));
		}
	      }
	  }
       System.err.println("end of performe ");

       if (childCnt == 0){
	 String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
	 TreeNodeInfo tn_new = new TreeNodeInfo(n);
	 top.add(new DefaultMutableTreeNode(tn_new));
	 childCnt++;
	 
       }
       return childCnt;
    }


public void getSelectedDirContent(TreePath selPath)
  {
    DefaultMutableTreeNode lastComponent = (DefaultMutableTreeNode)
                                           selPath.getLastPathComponent();

    Object o = lastComponent.getUserObject();
    TreeNodeInfo tinfo = (TreeNodeInfo)o;
    TreeNode removedOne = lastComponent.getChildAt(0); 
    
    if (isDirDummy(lastComponent))
      {
	//Construct subtree
	String selectedDir = getSelectedItem(selPath);
	
	lastComponent.removeAllChildren();
	int childCnt = updateTree(selectedDir,lastComponent,tinfo.filename);
	
	//announce dummy child is removed
	int[] childIndices = new int[1];
	childIndices[0] = 0;
	TreeNode[] removedChildren = new TreeNode[1];
	removedChildren[0] = removedOne;
	nodesWereRemoved((TreeNode)lastComponent,childIndices,
			  removedChildren);

	//announce some children added to current node	
        childIndices = new int[childCnt];
	for(int i=0;i<childCnt;i++) childIndices[i] = i;
        nodesWereInserted((TreeNode)lastComponent,childIndices);

      }
  }
  
public String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    Object pathComponent =  selPath.getPathComponent(pcount-1);
    
   
    String fullPath="";
    for(int i=0;i<pcount;i++){
      TreeNode tn = (TreeNode)(selPath.getPathComponent(i));
      Object o = ((DefaultMutableTreeNode)tn).getUserObject();
      TreeNodeInfo tinfo = (TreeNodeInfo)o;
      System.err.println("fn ="+tinfo.filename+" perm="+tinfo.permission);
      
      String append = "";
      if ((tinfo.permission.indexOf('d') == 0)||((pcount>1)&&(i==0)))
	append = "/";
      fullPath += tinfo.toString()+append;
    }
    
    return fullPath;
  }

public void treeExpanded(TreeExpansionEvent event)
  {
    System.err.println("treeExpanded is Called !!");
  
    TreePath selPath = event.getPath();
    System.err.println("selPath "+selPath.toString());
    System.err.println("selPath count ="+selPath.getPathCount());
        
      String newDirName = getSelectedItem(selPath);
      System.err.println("newDirName "+newDirName);
      
      if (newDirName.lastIndexOf("/") == newDirName.length() -1){
	getSelectedDirContent(selPath);
	System.err.println("Getting Ne directory contents: "+newDirName);
      }
    
  }

public void treeCollapsed(TreeExpansionEvent event)
  {
    System.err.println("treeCollapsed is Called !!");
  }


}



class TreeNodeInfo 
{
  String permission,ndirs,user,group,filesize,month,day,time,filename;
  int    nitems;
  
  public TreeNodeInfo (String fileInfo)
  {
    String tokens[] = new String[16];
    int i = 0;
    StringTokenizer st = new StringTokenizer(fileInfo," ",false);
    while(st.hasMoreTokens()){
      tokens[i] = st.nextToken();
      //System.err.println("next token "+tokens[i]);
      i++;
      
    }
    permission = tokens[0];
    ndirs      = tokens[1];
    user       = tokens[2];
    group      = tokens[3];
    filesize   = tokens[4];
    month      = tokens[5];
    day        = tokens[6];
    time       = tokens[7]; 
    filename   = tokens[8];
    for(int j=9;j<i;j++)
      filename += " "+tokens[j];
    
    if (i == 1) // directory name
      filename   = permission;
    nitems = i;
    
  }
  
  public String toString()
  {
    return filename;
  }   
}
