package EDU.auburn.VGJ.frontend;


import EDU.auburn.VGJ.*;
import EDU.auburn.VGJ.graph.*;
import EDU.auburn.VGJ.gui.*;
import EDU.syr.npac.frontend.CPanel;

import EDU.syr.npac.frontend.FEHash;

import java.util.*;

import java.net.*;

import java.io.*;

import org.omg.CORBA.*;
import WebFlow.*;
import WebFlow.QS.*;
import WebFlow.event.*;

public class compgraph {


  private NodeList List;

  private Node  node;

  private int   imax;

  private int    i,j;

  private int idx,id;

  private int   nedg;

  private String moduleName;

  GraphWindow GW;
  Hashtable edges;
  int ntotal;
  String hostName;
  String ClientID;
  int portNumber;
  CPanel am;
  FEHash FEclasses;
  compnode[] CompNodeList;
  compnode Cnode, fromCnode, toCnode;

  String moduleHost;
  String outNodeLabel, inNodeLabel;
  String EventID, MethodID;
  String xml;
  configReader config;
  xmlServer xmlp;
  int currentModule,inCardinal,outCardinal;

  public compgraph(GraphWindow GW_, NodeList NodeList_, Hashtable Edges_, String SM_URL) {

    List = NodeList_;

    GW = GW_;

    edges = Edges_;

    CompNodeList = new compnode[15];



  }





  public void tomnodelist () {




    System.err.println("======== RUN: START PROCESSING============");

    System.err.println("==========================================");

    xml="";
    moduleHost="localhost";

    FEclasses = new FEHash(); 
    imax = List.count();
    hostName = GW.hostName;
    ClientID = GW.ClientID;
    portNumber = GW.portNumber;   
    am = GW.tomPanel.Executor;
    ntotal=0;

 try {
    WebFlowContext master = Config.getGateway();
    System.out.println("compgraph: master OK");

//    userContext=a.getUserContext();
    System.out.println("connecting to server " + Config.getUserName());

   try{
       //org.omg.CORBA.Object o_user =master.getWFServer(Config.getUserName(),"dummy");
       org.omg.CORBA.Object o_user =master.getContext(Config.getMasterName() + "/" + Config.getUserName());
       System.out.println("dummy is created");
       
       WebFlowContext slave = WebFlowContextHelper.narrow(o_user);
       
       System.out.println("dummy is narrowed");
       
       if(slave == null) System.out.println("ERROR: slave not found!");
       else System.out.println("compgraph: slave/UserContext OK");


       //let the slave be the UserContext

    String ucr = Config.getORB().object_to_string(o_user);
    String an="TestApplication";

    System.out.println("compgraph: start generating XML");

    xml=xml+"<taskspec UserContextRef=\""+ucr+"\" User=\""+Config.getUserName()+"\">\n";
    xml=xml+"<task AppName=\""+an+"\">\n";

    System.out.println("compgraph: first node");
    currentModule =1;
    if(imax>0) {
      node = List.firstNode();
      node.setCardinal(currentModule); 
      moduleName=node.getLabel();
      // module host??
      xml=xml+"<module modulename=\""+moduleName+"."+currentModule+"\" host=\""+moduleHost+"\">\n";

      xml=xml+"</module>\n";

      addControls(moduleName);
      currentModule++;
    }


    System.out.println("compgraph: more nodes");

    if(imax>1) {

       for(i=1;i<imax;i++) {

          node = List.nextNode(node);
          node.setCardinal(currentModule); 
          moduleName=node.getLabel();

      moduleName=node.getLabel();

      // module host??

      xml=xml+"<module modulename=\""+moduleName+"."+currentModule+"\" host=\""+moduleHost+"\">\n";
      xml=xml+"</module>\n";
      addControls(moduleName);
      currentModule++;
       }
      }

      System.out.println("compgraph: now Edges ");
      
      Enumeration active_edges = edges.keys();

      while(active_edges.hasMoreElements())

	{

         SDPoint currEdge = (SDPoint)(active_edges.nextElement());

         System.err.println("compgrah: next edge......");
     
         Node fromNode = List.nodeFromIndex(currEdge.head_);

         outNodeLabel  = fromNode.getLabel();
         outCardinal    = fromNode.getCardinal();
         Node toNode = List.nodeFromIndex(currEdge.tail_);

         inNodeLabel = toNode.getLabel();

         inCardinal  = toNode.getCardinal();

	 /*

         Front End port numbering convention:


            0    1    2       input ports   (DESTINATION)

          ---------------

          |    module   |

          ---------------

          102   101  100      output ports  (SOURCE)


         */

         System.err.println("... find ports ID ...");







         // first output ports of fromNode  ("fromPort")





      int FEfromPort = currEdge.intDest;

      System.err.println("FrontEnd ID of output port: "+FEfromPort);



      EventID="Event"+FEfromPort;



         // then input ports of toNode ("toPort")



      int FEtoPort = currEdge.intSource;

      System.err.println("FrontEnd ID of input port: "+FEfromPort);



      MethodID="Method"+FEtoPort;

      xml=xml+"<connection>\n";

      xml=xml+"<out modulename=\""+outNodeLabel+"."+outCardinal+"\"  eventname=\""+EventID+"\"/>\n"; 

      xml=xml+"<in modulename=\""+inNodeLabel+"."+inCardinal+"\" method=\""+MethodID+"\"/>\n";
      xml=xml+"</connection>\n";
	}
      xml=xml+"</task>\n";
      xml=xml+"</taskspec>\n"; 

      System.out.println("compgraph: xml done ==========================");
      System.out.println(xml);
      System.out.println("compgraph: end of xml =========================");

     //xmlClient xmlc = new xmlClient(GW);
     //System.out.println("xmlClient created");
     //xmlc.toXML(xml); 

        System.out.println("add new module (xmlServer)");
	org.omg.CORBA.Object p1 = slave.addNewModule("xmlServer");
        if(p1 == null) System.out.println("ERROR: p1 not created ???");
        else System.out.println("compgraph: got p1 i.e., xmlServer object");

        xmlp = xmlServerHelper.narrow(p1);

        if(xmlp == null) System.out.println("xmlp is null ???");
        else System.out.println("compgraph: xmlp (xmlServer) OK");

        System.out.println("compgraph: save XML");
        xmlp.saveXML(xml,"test");
        String xmlFile = "test";
        System.out.println("compgraph: invoke the parser...");
        xmlp.parse(xmlFile);
        System.out.println("compgraph: parsing done!");
        }catch(Exception e){System.out.println("Main:"+e);
	}
    }catch(Exception e) {

        System.out.println(e);

	//System.err.println(ex.getMessage());

	//ex.printStackTrace();

	System.exit(1);

    }

  }

    public void rmReferences(){
	if(xmlp == null) {
          System.out.println("There is nothing to destroy");
	}
        else { 
          xmlp.rmRefs(Config.getUserName());
	}
    }

    public void addControls(String mname){
      ntotal++;
      if(ntotal>10) {System.out.println("too many modules!!!!!!!!!!!!!!!");} 
     Integer r1 = (Integer)FEclasses.ModuleNames.get(mname);
     System.out.println("R1: "+r1+" of "+ntotal);
     
     if(r1 != null) {
         int r2 = r1.intValue();
         System.out.println("add module of type "+r2);
         am.addNewModule(ntotal,r2,mname,moduleHost);
     }
     else {
        am.addNewModule(ntotal,0,mname,moduleHost);
     }
    }
} 




